Coin: SoDrawStyle Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

SoDrawStyle Class Reference
Node Classes

The SoDrawStyle class specifies common rendering properties for shapes. More...

`#include <Inventor/nodes/SoDrawStyle.h>`

Inheritance diagram for SoDrawStyle:

## Public Types
enum | Style { FILLED = SoDrawStyleElement::FILLED , LINES = SoDrawStyleElement::LINES , POINTS = SoDrawStyleElement::POINTS , INVISIBLE = SoDrawStyleElement::INVISIBLE }
Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 , INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 , COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 , COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 , COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000 }

## Public Member Functions
virtual SoType | getTypeId (void) const
| SoDrawStyle (void)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | pick (SoPickAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
SbUniqueId | getNodeId (void) const
virtual SoChildList * | getChildren (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes
SoSFEnum | style
SoSFFloat | pointSize
SoSFFloat | lineWidth
SoSFUShort | linePattern
SoSFInt32 | linePatternScaleFactor

## Protected Member Functions
virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoDrawStyle ()
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoDrawStyle class specifies common rendering properties for shapes.

Use SoDrawStyle nodes to influence how shape nodes following them in the scene graph will be rendered. This node type have fields to help decide how certain aspects of point-based shapes, line-based shapes and filled shape primitives are rendered.

Simple scene graph structure usage example:

#Inventor V2.1 ascii
Separator {
Sphere { }
Translation { translation 4 0 0 }
DrawStyle { style LINES lineWidth 2 }
Sphere { }
Translation { translation 4 0 0 }
DrawStyle { style POINTS pointSize 2 }
Sphere { }
}
SoDrawStyle::lineWidth
SoSFFloat lineWidth
Definition SoDrawStyle.h:61
SoDrawStyle::pointSize
SoSFFloat pointSize
Definition SoDrawStyle.h:60
SoDrawStyle::style
SoSFEnum style
Definition SoDrawStyle.h:59
SoDrawStyle::POINTS
@ POINTS
Definition SoDrawStyle.h:55
SoDrawStyle::LINES
@ LINES
Definition SoDrawStyle.h:54
Rendering of Example Scenegraph

FILE FORMAT/DEFAULTS:

DrawStyle {
style FILLED
pointSize 0
lineWidth 0
linePattern 0xffff
linePatternScaleFactor 1
}
SoDrawStyle::linePattern
SoSFUShort linePattern
Definition SoDrawStyle.h:62
SoDrawStyle::linePatternScaleFactor
SoSFInt32 linePatternScaleFactor
Definition SoDrawStyle.h:63
SoDrawStyle::FILLED
@ FILLED
Definition SoDrawStyle.h:53

## Member Enumeration Documentation

## ◆ Style

enum SoDrawStyle::Style

Enumeration for the various ways to render geometry.

Enumerator
FILLED | Render all geometry as-is.
LINES | Render all geometry as border lines.
POINTS | Render all geometry as vertex points.
INVISIBLE | Don't render geometry.

## Constructor & Destructor Documentation

## ◆ SoDrawStyle()

SoDrawStyle::SoDrawStyle | ( | void |  | ) |

Constructor.

## ◆ ~SoDrawStyle()

SoDrawStyle::~SoDrawStyle | ( |  | ) |
| protectedvirtual

Destructor.

## Member Function Documentation

## ◆ getClassTypeId()

SoType SoDrawStyle::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ getTypeId()

SoType SoDrawStyle::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Implements SoBase.

## ◆ getFieldDataPtr()

const SoFieldData ** SoDrawStyle::getFieldDataPtr | ( | void |  | ) |
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## ◆ getFieldData()

const SoFieldData * SoDrawStyle::getFieldData | ( | void |  | ) | const
| protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoFieldContainer.

## ◆ doAction()

void SoDrawStyle::doAction | ( | SoAction * | action | ) |
| virtual

This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

## ◆ GLRender()

void SoDrawStyle::GLRender | ( | SoGLRenderAction * | action | ) |
| virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

## ◆ callback()

void SoDrawStyle::callback | ( | SoCallbackAction * | action | ) |
| virtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

## Member Data Documentation

## ◆ style

SoSFEnum SoDrawStyle::style

How to render the geometry following a draw style node in the scene graph. Default SoDrawStyle::FILLED.

## ◆ pointSize

SoSFFloat SoDrawStyle::pointSize

Size in screen pixels of SoPointSet points, and also of geometry vertex points if setting the SoDrawStyle::style to SoDrawStyle::POINTS.

The valid range of point size settings varies according to which OpenGL implementation is used. For the purpose of not trying to set illegal values, the application programmer should at runtime check the valid range. How this can be accomplished is described in the class documentation of SoGLPointSizeElement.

Default value is 0.0f, which is a "tag" value which tells the rendering library to use the default setting.

## ◆ lineWidth

SoSFFloat SoDrawStyle::lineWidth

Width in screen pixels of SoLineSet and SoIndexedLineSet lines, and also of geometry border lines if setting the SoDrawStyle::style to SoDrawStyle::LINES.

The valid range of line width settings varies according to which OpenGL implementation is used. For the purpose of not trying to set illegal values, the application programmer should at runtime check the valid range. How this can be accomplished is described in the class documentation of SoGLLineWidthElement.

Default value is 0.0f, which is a "tag" value which tells the rendering library to use the default setting.

## ◆ linePattern

SoSFUShort SoDrawStyle::linePattern

Pattern as a bitmask used when drawing lines. Default is 0xffff (no "holes").

## ◆ linePatternScaleFactor

SoSFInt32 SoDrawStyle::linePatternScaleFactor

Multiplier for the bitmask in linePattern (range 1 - 256). Default is 1.

The documentation for this class was generated from the following files:

- SoDrawStyle.h
- SoDrawStyle.cpp